source/apps/crawl_space/urls.py
"""Crawl space url routes.

Each of these url patterns is built off a project URL-

    /project/<project_slug>

-and belongs to the "crawl_space" namespace. See `base.urls` for an
explanation of the dynamic route generation.

URLs
----

project/<project_slug>/
    add_crawl/
    add_crawl_model/
    crawls/
    crawls/<crawl_slug/

"""

from django.conf.urls import patterns, url

from apps.crawl_space import views

urlpatterns = patterns('',
    url(r'^add_crawl/$', views.AddCrawlView.as_view(),
        name='add_crawl'),
    url(r'^add_crawl_model/$', views.AddCrawlModelView.as_view(),
        name='add_crawl_model'),
    url(r'^(?P<model_slug>[\w-]+)/delete/$', views.DeleteCrawlModelView.as_view(),
        name='delete_crawl_model'),
    url(r'^crawls/$', views.ListCrawlsView.as_view(),
        name='crawls'),
    url(r'^crawls/(?P<crawl_slug>[\w-]+)/$', views.CrawlView.as_view(),
        name='crawl'),
    url(r'^crawls/(?P<crawl_slug>[\w-]+)/settings/$', views.CrawlSettingsView.as_view(),
        name='crawl_settings'),
    url(r'^crawls/(?P<crawl_slug>[\w-]+)/settings/delete/$', views.DeleteCrawlView.as_view(),
        name='delete_crawl'),
)

source/base/urls.py
"""Base url routes.

This module also dynamically adds url routes to applications present in
INSTALLED_APPS; see the comments below.

URLs
----

/
about/
add_project/
project/

"""

from django.conf.urls import patterns, include, url
from base import views


project_slug = r'^projects/(?P<project_slug>[\w-]+)/'

urlpatterns = patterns('',
    url(r'^$', views.IndexView.as_view(), name='index'),
    url(r'^seeds/$', views.SeedsListView.as_view(), name='seeds_list'),
    url(r'^seeds/(?P<seeds_slug>[\w-]+)/$', views.EditSeedsView.as_view(), name='edit_seeds'),
    url(r'^about/$', views.AboutView.as_view(), name='about'),
    url(r'^add_project/$', views.AddProjectView.as_view(),
        name='add_project'),
    url(project_slug + r'$', views.ProjectView.as_view(),
        name='project'),
    url(project_slug + r'settings/$', views.ProjectSettingsView.as_view(),
        name='project_settings'),
    url(project_slug + r'tad/$', views.TadView.as_view(),
        name='tad'),
    url(project_slug + r'settings/delete/$', views.DeleteProjectView.as_view(),
        name='delete_project'),
    url(project_slug + r'add_dataset/$', views.AddIndexView.as_view(),
        name='add_index'),
    url(project_slug + r'datasets/$', views.ListIndicesView.as_view(),
        name='indices'),
    url(project_slug + r'datasets/(?P<index_slug>[\w-]+)/settings/$',
        views.IndexSettingsView.as_view(), name='index_settings'),
    url(project_slug + r'datasets/(?P<index_slug>[\w-]+)/settings/delete/$',
        views.DeleteIndexView.as_view(), name='delete_index'),
)


# The following lines build a url route to each application listed in
#   `settings.EXPLORER_APPS`, namespaced appropriately.
#   See <https://github.com/ContinuumIO/memex-explorer/issues/316>

from django.conf import settings

inject_urls = [
    url(project_slug, include('apps.%s.urls' % app, namespace=app))
    for app in settings.EXPLORER_APPS
]

urlpatterns += patterns('', *inject_urls)

source/memex/urls.py
from django.conf.urls import patterns, include, url
from django.contrib import admin

from rest import router, DataWakeView


urlpatterns = patterns('',
    url(r'', include('base.urls', namespace="base")),
    url(r'^admin/', include(admin.site.urls)),
    url(r'^api/', include(router.urls)),
    url(r'^api/datawake/$', DataWakeView.as_view(), name="datawake"),
    url(r'^api-auth/', include('rest_framework.urls', namespace='rest_framework')),
)

source/apps/crawl_space/models.py
import os
import shutil

from os.path import join

from django.db import models
from django.utils.text import slugify
from django.core.urlresolvers import reverse
from django.core.exceptions import ValidationError, NON_FIELD_ERRORS
from django.core.files.base import ContentFile
from django.core.files.uploadedfile import SimpleUploadedFile

from base.models import Project, SeedsList, alphanumeric_validator
from apps.crawl_space.utils import ensure_exists

from apps.crawl_space.settings import (crawl_resources_dir, resources_dir,
    MODEL_PATH, CRAWL_PATH, SEEDS_TMP_DIR, MODELS_TMP_DIR)


def validate_model_file(value):
    if value != 'pageclassifier.model':
        raise ValidationError("Model file must be named 'pageclassifier.model'.")


def validate_features_file(value):
    if value != 'pageclassifier.features':
        raise ValidationError("Features file must be named 'pageclassifier.features'.")


def get_model_upload_path(instance, filename):
    """
    This method must stay outside of the class definition because django
    cannot serialize unbound methods in Python 2:

    https://docs.djangoproject.com/en/dev/topics/migrations/#migration-serializing
    """
    return os.path.join(MODEL_PATH, instance.name, filename)


class CrawlModel(models.Model):
    """CrawlModel model, specifically for ACHE crawls.

    Model Fields
    ------------

    name : str, 64 characters max
    model : FileField
        Upload pageclassifier.model file
    features : FileField
        Upload pageclassifier.features file
    project : fk to base.Project

    """

    def get_model_path(self):
        return join(MODEL_PATH, self.name)

    def ensure_model_path(self):
        model_path = self.get_model_path()
        ensure_exists(model_path)
        return model_path

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    model = models.FileField(upload_to=get_model_upload_path,
        validators=[validate_model_file])
    features = models.FileField(upload_to=get_model_upload_path,
        validators=[validate_features_file])
    project = models.ForeignKey(Project)

    def get_absolute_url(self):
        return reverse('base:project',
            kwargs=dict(project_slug=self.project.slug))

    def save(self, *args, **kwargs):
        if self.pk is None:
            self.slug = slugify(self.name)
            # TODO:
            # Another weird call with a side effect that has to be fixed.
            model_path = self.ensure_model_path()

        return super(CrawlModel, self).save(*args, **kwargs)

    @property
    def url(self):
        return self.get_absolute_url()

    def __unicode__(self):
        return self.name


def get_seeds_upload_path(instance, filename):
    """
    This method must stay outside of the class definition because django
    cannot serialize unbound methods in Python 2:

    https://docs.djangoproject.com/en/dev/topics/migrations/#migration-serializing
    """
    if instance.crawler == "nutch":
        seeds_list_path = os.path.join(CRAWL_PATH, instance.slug, "seeds", "seeds")
    elif instance.crawler == "ache":
        seeds_list_path = os.path.join(CRAWL_PATH, instance.slug, "seeds")
    return seeds_list_path


class Crawl(models.Model):
    """Crawl model.

    Model Fields
    ------------

    name : str, 64 characters max
    slug : str, 64 characters max
        The `slug` field is derived from `name` on save, and is restricted
        to URL-safe characters.
    description : str
    crawler : str
        Either 'nutch' or 'ache'
    status : str
    config : str
        [ACHE] Name of configuration directory, defaults to "config_default"
    seeds_list : FileField
        Upload text file containing seed URLs
    pages_crawled : int
    harvest_rate : float
        [ACHE] Ratio of relevant pages in the crawl
    project : fk to base.Project
    crawl_model : fk to CrawlModel
    """

    def get_crawl_path(self):
        return join(self.crawl_location)

    def get_config_path(self):
        return os.path.join(self.crawl_location, "config")

    def ensure_crawl_path(self):
        crawl_path = self.crawl_location
        ensure_exists(crawl_path)
        return crawl_path

    def get_default_config(self):
        return os.path.join(crawl_resources_dir, "configs", "config_default")

    def get_solr_url(self):
        return SOLR_URL

    CRAWLER_CHOICES = (
        ('nutch', "Nutch"),
        ('ache', "ACHE"))

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    description = models.TextField(blank=True)
    crawler = models.CharField(max_length=64, choices=CRAWLER_CHOICES)
    status = models.CharField(max_length=64, default="NOT STARTED")
    config = models.CharField(max_length=64, default="config_default")
    seeds_object = models.ForeignKey(SeedsList, on_delete=models.PROTECT)
    seeds_list = models.FileField(default=None, null=True, blank=True, upload_to=get_seeds_upload_path)
    pages_crawled = models.BigIntegerField(default=0)
    harvest_rate = models.FloatField(default=0)
    project = models.ForeignKey(Project)
    crawl_model = models.ForeignKey(CrawlModel, null=True, blank=True,
        default=None, on_delete=models.PROTECT)
    rounds_left = models.IntegerField(default=1, null=True, blank=True)

    def save(self, *args, **kwargs):
        if self.pk is None:
            self.slug = slugify(unicode(self.name))
            # TODO:
            # Fix this function and its weird side effect. Without this line the
            # save method wont work.
            crawl_path = self.ensure_crawl_path()
            # If the crawler is ache, copy the config. If config already exists,
            # delete it.
            if self.crawler == 'ache':
                if os.path.exists(self.get_config_path()):
                    shutil.rmtree(self.get_config_path())
                shutil.copytree(self.get_default_config(), self.get_config_path())
                self.config = self.get_config_path()
                self.seeds_list = SimpleUploadedFile("seeds", bytes(self.seeds_object.to_file_string()))
            elif self.crawler == "nutch":
                self.seeds_list = SimpleUploadedFile("seeds", bytes(self.seeds_object.to_file_string()))
        return super(Crawl, self).save(*args, **kwargs)

    # TODO:
    # This is redundant. URL property is better.
    def get_absolute_url(self):
        return reverse('base:crawl_space:crawl',
            kwargs=dict(project_slug=self.project.slug, crawl_slug=self.slug))

    @property
    def url(self):
        return self.get_absolute_url()

    @property
    def index_name(self):
        return "%s_%s_%s" % (self.slug, self.project.slug, self.crawler)

    @property
    def crawl_location(self):
        return os.path.join(resources_dir, "crawls", self.slug)

    def __unicode__(self):
        return self.name

source/base/models.py
"""Base models."""

import os
import subprocess
import shutil
import json

from django.db import models
from django.utils.text import slugify
from django.core.urlresolvers import reverse
from django.core.validators import RegexValidator
from django.core.urlresolvers import reverse
from django.db.models.signals import post_save

from jinja2 import Template
from jinja2.runtime import Context

from django.conf import settings


def alphanumeric_validator():
    return RegexValidator(r'^[a-zA-Z0-9-_ ]+$',
        'Only numbers, letters, underscores, dashes and spaces are allowed.')


def zipped_file_validator():
    return RegexValidator(r'.*\.(ZIP|zip)$',
        'Only compressed archive (.zip) files are allowed.')


class Project(models.Model):
    """Project model.

    Every application that plugs into Memex Explorer should have a
    foreign key relationship to a Project.

    Model Fields
    ------------

    name : str, 64 characters max
    slug : str, 64 characters max
        The `slug` field is derived from `name` on save, and is restricted
        to URL-safe characters.
    description : textfield

    """

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    description = models.TextField(blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(unicode(self.name))
        super(Project, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('base:project',
            kwargs=dict(project_slug=self.slug))

    @property
    def url(self):
        return self.get_absolute_url()

    def kibana_url(self):
        return '/{}/kibana/'.format(self.name)

    def __unicode__(self):
        return self.name


def get_zipped_data_path(instance, filename):
    """
    This method must stay outside of the class definition because django
    cannot serialize unbound methods in Python 2:

    https://docs.djangoproject.com/en/dev/topics/migrations/#migration-serializing
    """
    return os.path.join(settings.MEDIA_ROOT, "indices", instance.slug, "zipped_data", filename)


class Index(models.Model):
    """Index model.

    The index model keeps track of indices that are made and what files are
    contained within them.

    Model Fields
    ------------

    name : str, 64 characters max
    description : textfield
    uploaded_data : Django FileField
    data_dolder : textfield
    project : fk to base.Project

    """
    def get_dumped_data_path(instance):
        return os.path.join(
            settings.MEDIA_ROOT,
            "indices",
            instance.slug,
            "data"
        )

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    uploaded_data = models.FileField(upload_to=get_zipped_data_path,
        validators=[zipped_file_validator()])
    data_folder = models.TextField(blank=True)
    project = models.ForeignKey(Project)
    status = models.CharField(max_length=64, default="")
    num_files = models.IntegerField(default=0)

    def save(self, *args, **kwargs):
        self.slug = slugify(unicode(self.name))
        self.data_folder = self.get_dumped_data_path()
        super(Index, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('base:project',
            kwargs=dict(project_slug=self.project.slug))

    @property
    def index_name(self):
        return "%s_%s_%s" % (self.slug, self.project.slug, "dataset")

    def __unicode__(self):
        return self.name


class SeedsList(models.Model):
    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    seeds = models.TextField()

    def save(self, *args, **kwargs):
        self.slug = slugify(unicode(self.name))
        super(SeedsList, self).save(*args, **kwargs)

    def to_file_string(self):
        return "\n".join(json.loads(self.seeds))

    def get_absolute_url(self):
        return reverse('base:edit_seeds',
            kwargs=dict(seeds_slug=self.slug))

    @property
    def url(self):
        return self.get_absolute_url()

    @property
    def file_string(self):
        return self.to_file_string()

    def __unicode__(self):
        return self.name

source/base/templates/base/add_project.html
{% extends "base/base.html" %}
{% load crispy_forms_tags %}

{% block title %}Add Project{% endblock %}

{% block content %}

<div class='row'>
	<div class="col-md-offset-2 col-md-10">
          <ol class="breadcrumb">
            <li> <a href="/"> / My Projects / </a></li> Add Project
          </ol>
    </div>
    <div class="col-xs-8 col-xs-offset-2 col-sm-6 col-sm-offset-3 main">
        <div class="center">
            <h1>Add Project</h1>
            {% crispy form %}
        </div>
    </div>
</div>

{% endblock %}

source/base/templates/base/edit_seeds.html
{% extends "base/base.html" %}

{% block title %}{{seedslist.name}}{% endblock %}

{% load static %}

{% block extrahead %}
    <link href="{% static 'base/css/codemirror.css' %}" rel="stylesheet">
{% endblock %}

{% block extrafooter %}
    <script src="{% static 'base/js/ajax.js' %}"></script>
    <script src="{% static 'base/js/codemirror-compressed.js' %}"></script>
    <script src="{% static 'base/js/backbone/base_views.js' %}"></script>
    <script src="{% static 'base/js/backbone/seeds.js' %}"></script>
    <script src="{% static 'base/js/backbone/edit_seeds_backbone.js' %}"></script>
{% endblock %}

{% block content %}
<div class='row'>

  <div class="col-md-offset-1 col-md-10">
    <ol class="breadcrumb">
      <li><a href="/seeds"> / Seeds / </a></li> {{ seedslist.name }}
    </ol>
  </div>
  <div class="col-sm-5 col-sm-offset-4 col-md-5 col-md-offset-4">
    <div id="seedsSuccess" class="alert alert-success alert-dismissible" role="alert" hidden>
      <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
      Seeds list successfully saved.
    </div>
  </div>
  <div class="col-sm-5 col-sm-offset-4 col-md-5 col-md-offset-4">
    <div id="seedsFailure" class="alert alert-danger alert-dismissible" role="alert" hidden>
      <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
      There were invalid URLs in your seeds list.
    </div>
  </div>
  <div class="col-sm-10 col-sm-offset-1 col-md-10 col-md-offset-1">
    <input id="seeds_pk" type="hidden" value="{{ seedslist.id }}">
    <div id="seeds"></div>
  </div>
<script>

</script>

</div>
{% include "base/underscore_templates/underscore_templates.html" %}
{% include "base/underscore_templates/seeds_underscore.html" %}
{% include "base/underscore_templates/crawls_underscore.html" %}
{% endblock %}

source/base/templates/base/indices.html
{% extends "base/base.html" %}
{% load static %}

{% block title %}{{project.name}}: Datasets{% endblock %}
{% block content %}

{% include "base/sidebar.html" %}

<div class='row'>
   
    <div class="col-sm-5 col-sm-offset-3 col-sm-5  col-md-offset-2 main">
        <h1>Datasets
            <a id="gotoKibana"
                style="float:right;"
                class="btn btn-default btn-duo center link-button"
                href="{{ kibana }}">
                Kibana
            </a>
        </h1>
    </div>
    {% for index in project.index_set.all %}
    <div class="col-sm-9 col-sm-offset-3 col-md-10 col-md-offset-2 main">
        <p>{{ index.name }}</p>
    <a target="_blank" href="{% url 'base:index_settings' project_slug=project.slug index_slug=index.slug %}">
      <button id="editButton" title="Edit Project" type="button" class="btn btn-control"
      data-container="body"
      data-toggle="tooltip" data-placement="bottom">
      <i class="fa fa-gears" style="font-size:24px;"></i>
    </button></a>
    <div class="col-sm-6">
        <table class="table table-striped">
            <tr>
                <th>Number of Files</th>
            </tr>
            <tr>
                <td>{{ index.num_files }}</td>
            </tr>
        </table>
    </div>
    </div>



    {% empty %}
        <div class="col-sm-9 col-sm-offset-3 col-md-10 col-md-offset-2 main">
            <p>There are no indices associated with this project.</p>
        </div>



    {% endfor %}
    <div class="col-sm-9 col-sm-offset-3 col-md-10 col-md-offset-2 main">
        <div class="col-sm-6">
            <a target="_blank" class="btn btn-default btn-duo center link-button" style="float:right;" href="{% url 'base:add_index' project_slug=project.slug %}">Add Dataset</a>
        </div>
    </div>
</div>
{% endblock %}

source/base/templates/base/project.html
{% extends "base/base.html" %}

{% block title %}{{project.name}}{% endblock %}

{% load static %}

{% block extrahead %}
    <link href="{% static 'base/css/codemirror.css' %}" rel="stylesheet">
{% endblock %}

{% block extrafooter %}
    <script src="{% static 'base/js/codemirror-compressed.js' %}"></script>
    <script src="{% static 'base/js/ajax.js' %}"></script>
    <script src="{% static 'base/js/project.js' %}"></script>
    <script src="{% static 'base/js/backbone/base_views.js' %}"></script>
    <script src="{% static 'base/js/backbone/seeds.js' %}"></script>
    <script src="{% static 'base/js/backbone/project_seeds.js' %}"></script>
    <script src="{% static 'base/js/backbone/crawl_models.js' %}"></script>
    <script src="{% static 'base/js/backbone/crawls.js' %}"></script>
    <script src="{% static 'base/js/backbone/project_router.js' %}"></script>
{% endblock %}

{% block content %}

<script>
  $( document ).ready(function() {
    $('[data-toggle="tooltip"]').tooltip();
  });
</script>

<style>
</style>
<!--
{% include "base/sidebar.html" %}
-->

<div class='row'>

  <div class="col-md-offset-1 col-md-10">
    <ol class="breadcrumb">
      <li> <a href="/"> / My Projects / </a></li> {{ project.name }}
    </ol>
  </div>
  <div class="col-sm-10 col-sm-offset-1 col-md-10 col-md-offset-1">
      <h1>{{ project.name }}
      <a href="{% url 'base:project_settings' project_slug=project.slug %}">
        <button id="editButton" title="Edit Project" type="button" class="btn btn-control"
        data-container="body"
        data-toggle="tooltip" data-placement="bottom">
        <i class="fa fa-pencil" style="font-size:24px;"></i>
        </button></a>
      </h1>
      <p>{{ project.description }}</p>
  </div>

</div>

<div class='row'>
  <input type="hidden" id="project_id" value="{{ project.id }}">
  <div class="col-md-10 col-md-offset-1 main">

    <div class="row">
            <button type="button" class="btn btn-default btn-duo center link-button" data-toggle="modal" data-target="#addCrawlModal">
             START A NEW CRAWL
            </button>
            <div class="modal fade" id="addCrawlModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
              <div class="modal-dialog" role="document">
                <div class="modal-content">
                  <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title" id="myModalLabel">Add Crawl</h4>
                  </div>
                  <div class="modal-body" id="addCrawlContainer"></div>
                </div>
              </div>
            </div>

            {% if "ddt" in settings.READY_EXTERNAL_APPS %}
            <a class="btn btn-default btn-duo center link-button" href={{settings.EXTERNAL_APP_LOCATIONS.ddt}}>Domain Discovery </a>
            {% endif %}
            {% if "tad" in settings.READY_EXTERNAL_APPS %}
            <a class="btn btn-default btn-duo center link-button"
            href="tad">Temporal Anomalies </a>
            {% endif %}


    </div>

    <div id="crawlTableDiv" class="row"></div>
    <hr/>

    <div class="row">
            <a target="_blank" class="add_index btn btn-default btn-duo center link-button" href="{% url 'base:add_index' project_slug=project.slug %}">Add a new Dataset</a>
      <h4 style="line-height:2em;">
          <i class="fa fa-archive"> &nbsp; </i>Datasets
        </a>
      </h4>

      {% if project.index_set.all %}
      <table id="statuses" class="table table-condensed table-gray table-bordered">
        <tr>
          <th>Dataset Name</th>

          <th>Status</th>
          <th>Actions</th>
        </tr>
        {%  for w in project.index_set.all %}
        <tr>
          <td>
            <a href={% url 'base:index_settings' project_slug=project.slug index_slug=w.slug %}>
                &nbsp{{ w.name }}
            </a>
          </td>


          <td>
            <div id={{ w.slug }}>{{ w.status }}</div>
          </td>
          <td>
            <a target="_blank" href="{% url 'base:index_settings' project_slug=project.slug index_slug=w.slug %}">
              <i class="fa fa-pencil"></i>
            </a>
            &nbsp;&nbsp;
             <form style="display:inline" action="{% url 'base:delete_index' project_slug=project.slug index_slug=w.slug %}"
            method="post" onSubmit="return confirm('Are you sure you want to delete this dataset?')">
                {% csrf_token %}
            <a href="#"><button class="fa fa-trash no-style-btn" type="submit"></button></a>
            </form>
            &nbsp;&nbsp;
            <a id="gotoKibana" target="_blank" href="{{ kibana }}">
              <i class="fa fa-pie-chart"> &nbsp; </i>
            </a>
          </td>
        </tr>
        {% endfor %}
      </table>
      {% else %}
      <p>No Datasets Registered.</p>
      {% endif %}
    </div>
    <hr/>

    <div class="row">
                  <button type="button" class="btn btn-default btn-duo center link-button" data-toggle="modal" data-target="#crawlModelModal">
             ADD CRAWL MODEL
            </button>
            <div class="modal fade" id="crawlModelModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
              <div class="modal-dialog" role="document">
                <div class="modal-content">
                  <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title" id="myModalLabel">Add Crawl Model</h4>
                  </div>
                  <div class="modal-body" id="addCrawlModelContainer"></div>
                </div>
              </div>
            </div>

            <div class="modal fade" id="newSeedsModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <h4 class="modal-title" id="myModalLabel">Add Seeds</h4>
                        </div>
                        <div class="modal-body" id="addSeedsContainer"></div>
                    </div>
                </div>
            </div>
    <div id="crawlModelTableDiv">
    </div>
    </div>
  </div>
  </div>
{% include "base/underscore_templates/underscore_templates.html" %}
{% include "base/underscore_templates/seeds_underscore.html" %}
{% include "base/underscore_templates/crawls_underscore.html" %}
{% endblock %}

source/base/templates/base/project_update_form.html
{% extends "base/base.html" %}
{% load crispy_forms_tags %}

{% block title %}Edit Project{% endblock %}

{% block content %}

<div class='row'>
    <div class="col-xs-8 col-xs-offset-2 col-sm-6 col-sm-offset-3 main">
        <div class="col-sm-6">
            <h1>Edit Project</h1>
        </div>
        <div class="col-sm-6">
          <form style="
              display:inline;
              float:right;
              margin-top:20px;
              margin-bottom:10px;
              background:none;
            "
            action="{% url 'base:delete_project' project_slug=project.slug %}"
            method="post" onSubmit="return confirm('Are you sure you want to delete this project?')">
            {% csrf_token %}
            <button
                class="fa fa-trash-o btn btn-control"
                style="
                    font-size:32px;
                "
                type="submit">
            </button>
        </form>
        </div>
    </div>
    <div class="col-xs-8 col-xs-offset-2 col-sm-6 col-sm-offset-3 main">
        <div class="center">
            {% crispy form %}
        </div>
    </div>
</div>
{% endblock %}

{% load staticfiles %}

{% block extrahead %}
    <link href="{% static 'base/css/update.css' %}" rel="stylesheet">
{% endblock %}

source/base/templates/base/sidebar.html
<div class="col-sm-3 col-md-2 sidebar">
  <a href="{% url 'base:project' project_slug=project.slug %}"><h2>{{ project.name }}</h2></a>
  <div class="accordion" id="accordion2">
    <div class="accordion-group">
      <div class="accordion-heading sidebar-buttons">
        Crawls
      <a class="accordion-toggle" data-toggle="collapse" data-parent="#accordion2" href="#collapseOne"  style='float:right;'><i class="fa fa-list"></i></a>
    </div>
    <div id="collapseOne" class="accordion-body collapse accordion-links">
      {% if project.crawl_set.all %}
      {% for w in project.crawl_set.all %}
      <div class="accordion-inner">
          <a href="{{ w.get_absolute_url }}">{{ w.name }}</a>
      </div>
      {% endfor %}
      {% endif %}
    </div>
  </div>
</div>
  <div class="accordion" id="accordion3">
    <div class="accordion-group">
      <div class="accordion-heading sidebar-buttons">
        Datasets
      <a class="accordion-toggle" data-toggle="collapse" data-parent="#accordion3" href="#collapseThree"  style='float:right;'><i class="fa fa-list"></i></a>
    </div>
    <div id="collapseThree" class="accordion-body collapse accordion-links">
      {% if project.index_set.all %}
      {% for w in project.index_set.all %}
      <div class="accordion-inner">
          <a href="{{ w.get_absolute_url }}">{{ w.name }}</a>
      </div>
      {% endfor %}
      {% endif %}
      <div class="accordion-inner">
        <a target="_blank" href="{% url 'base:add_index' project_slug=project.slug %}">+ Add Dataset</a>
      </div>
    </div>
  </div>
</div>
</div>
</div>